# Ogre::ColourInterpolatorAffector Class Reference

`#include <OgreColourInterpolatorAffector.h>`

Inheritance diagram for Ogre::ColourInterpolatorAffector:

List of all members.

## Public Types

enum | { MAX_STAGES = 6 }

## Public Member Functions

| ColourInterpolatorAffector (ParticleSystem *psys)
| Default constructor.
void | _affectParticles (ParticleSystem *pSystem, Real timeElapsed)
| See ParticleAffector.
void | setColourAdjust (size_t index, ColourValue colour)
ColourValue | getColourAdjust (size_t index) const
void | setTimeAdjust (size_t index, Real time)
Real | getTimeAdjust (size_t index) const
virtual void | _initParticle (Particle *pParticle)
| Method called to allow the affector to initialize all newly created particles in the system.
const String & | getType (void) const
| Returns the name of the type of affector.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.

## Static Public Member Functions

static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Static Public Attributes

static CmdColourAdjust | msColourCmd [MAX_STAGES]
static CmdTimeAdjust | msTimeCmd [MAX_STAGES]

## Protected Member Functions

void | addBaseParameters (void)
| Internal method for setting up the basic parameter definitions for a subclass.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Protected Attributes

ColourValue | mColourAdj [MAX_STAGES]
Real | mTimeAdj [MAX_STAGES]
String | mType
| Name of the type of affector, MUST be initialised by subclasses.
ParticleSystem * | mParent
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).

## Static Protected Attributes

static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Classes

class | CmdColourAdjust
| Command object for red adjust (see ParamCommand). More...
class | CmdTimeAdjust
| Command object for red adjust (see ParamCommand). More...

## Member Enumeration Documentation

anonymous enum

Enumeration values:

  MAX_STAGES |

Definition at line 42 of file OgreColourInterpolatorAffector.h.

## Constructor & Destructor Documentation

Ogre::ColourInterpolatorAffector::ColourInterpolatorAffector | ( | ParticleSystem * | psys | ) |

| Default constructor.

## Member Function Documentation

void Ogre::ColourInterpolatorAffector::_affectParticles | ( | ParticleSystem * | pSystem,
|  | Real | timeElapsed
| ) | `[virtual]`

| See ParticleAffector. Implements Ogre::ParticleAffector.

virtual void Ogre::ParticleAffector::_initParticle | ( | Particle * | pParticle | ) | `[virtual, inherited]`

Method called to allow the affector to initialize all newly created particles in the system.

Remarks:
  This is where the affector gets the chance to initialize it's effects to the particles of a system. The affector is expected to initialize some or all of the particles in the system passed to it, depending on the affector's approach.

Parameters:

  | pParticle | Pointer to a Particle to initialize.

Reimplemented in Ogre::ColourImageAffector, and Ogre::RotationAffector.

Definition at line 85 of file OgreParticleAffector.h.

void Ogre::ParticleAffector::addBaseParameters | ( | void |  | ) | `[protected, inherited]`

Internal method for setting up the basic parameter definitions for a subclass.

Remarks:
  Because StringInterface holds a dictionary of parameters per class, subclasses need to call this to ask the base class to add it's parameters to their dictionary as well. Can't do this in the constructor because that runs in a non-virtual context.

  The subclass must have called it's own createParamDictionary before calling this method.

Definition at line 68 of file OgreParticleAffector.h.

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 296 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 172 of file OgreStringInterface.h.

ColourValue Ogre::ColourInterpolatorAffector::getColourAdjust | ( | size_t | index | ) | const

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 209 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 196 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 265 of file OgreStringInterface.h.

References Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

Real Ogre::ColourInterpolatorAffector::getTimeAdjust | ( | size_t | index | ) | const

const String& Ogre::ParticleAffector::getType | ( | void |  | ) | const`[inherited]`

Returns the name of the type of affector.

Remarks:
  This property is useful for determining the type of affector procedurally so another can be created.

Definition at line 104 of file OgreParticleAffector.h.

void Ogre::ColourInterpolatorAffector::setColourAdjust | ( | size_t | index,
|  | ColourValue | colour
| ) |

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

void Ogre::ColourInterpolatorAffector::setTimeAdjust | ( | size_t | index,
|  | Real | time
| ) |

## Member Data Documentation

ColourValue Ogre::ColourInterpolatorAffector::mColourAdj[MAX_STAGES]`[protected]`

| Definition at line 84 of file OgreColourInterpolatorAffector.h.

String Ogre::StringInterface::mParamDictName `[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 160 of file OgreStringInterface.h.

ParticleSystem* Ogre::ParticleAffector::mParent `[protected, inherited]`

| Definition at line 70 of file OgreParticleAffector.h.

CmdColourAdjust Ogre::ColourInterpolatorAffector::msColourCmd[MAX_STAGES]`[static]`

| Definition at line 80 of file OgreColourInterpolatorAffector.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary `[static, protected, inherited]`

| Dictionary of parameters. Definition at line 157 of file OgreStringInterface.h.

CmdTimeAdjust Ogre::ColourInterpolatorAffector::msTimeCmd[MAX_STAGES]`[static]`

| Definition at line 81 of file OgreColourInterpolatorAffector.h.

Real Ogre::ColourInterpolatorAffector::mTimeAdj[MAX_STAGES]`[protected]`

| Definition at line 85 of file OgreColourInterpolatorAffector.h.

String Ogre::ParticleAffector::mType `[protected, inherited]`

| Name of the type of affector, MUST be initialised by subclasses. Definition at line 58 of file OgreParticleAffector.h.

The documentation for this class was generated from the following file:

- OgreColourInterpolatorAffector.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Sep 17 15:46:35 2006